# Generated by 02-duckplyr_df-methods.R
#' @export
nest_by.duckplyr_df <- function(.data, ..., .key = "data", .keep = FALSE) {
  # Our implementation
  duckplyr_error <- rel_try(NULL,
    "No relational implementation for {.code nest_by()}" = TRUE,
    {
      return(out)
    }
  )

  # dplyr forward
  check_prudence(.data, duckplyr_error)

  nest_by <- dplyr$nest_by.data.frame
  out <- nest_by(.data, ..., .key = .key, .keep = .keep)
  return(out)

  # dplyr implementation
  .data <- group_by(.data, ...)
  # nest_by.grouped_df(.data, .key = .key, .keep = .keep)
}

duckplyr_nest_by <- function(.data, ...) {
  try_fetch(
    .data <- as_duckplyr_df_impl(.data),
    error = function(e) {
      testthat::skip(conditionMessage(e))
    }
  )
  out <- nest_by(.data, ...)
  class(out) <- setdiff(class(out), "duckplyr_df")
  out
}
